Index: trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp
===================================================================
--- trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 405)
+++ trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 434)
@@ -1687,596 +1202,224 @@
         // Invalidation on IOTLB
         bool    ok;
-        ok = r_iotlb.inval(r_config_tlb_inval_vaddr.read());
+        ok = r_iotlb.inval(r_config_cmd_inval_vaddr.read());
          
-        if(r_waiting_transaction.read()) r_dma_tlb_fsm =DMA_TLB_WAIT_TRANSACTION; 
-        else r_dma_tlb_fsm = DMA_TLB_IDLE;
+        if(r_waiting_transaction.read()) r_tlb_fsm =TLB_WAIT; 
+        else r_tlb_fsm = TLB_IDLE;
         break; 
     }
-    } //end switch r_dma_tlb_fsm
+    } //end switch r_tlb_fsm
     
-    
-    /////////////////////////////////////////////////////////////////////
-    // The CONFIG_CMD_FSM is similar to the DMA_CMD_FSM, but without miss TLB treatment.
-    // It controls the following ressources:
-    // - r_config_cmd_fsm
-    //
-    // - r_config_cmd_rsp_erase_req (set)
-    // - r_config_tlb_req (set)
-    /////////////////////////////////////////////////////////////////////
+    ////////////////////////////////////////////////////////////////////////////////
+    // The CONFIG_CMD_FSM handles the VCI commands from the INT network.
+    // This FSM is mainly intended to handle single flit config transactions, 
+    // but it can also handle software driven, multi-flits data transactions.
+    // - The configuration requests can be local (IO_BRIDGE config registers)
+    //   or remote (config registers of peripherals on IOX network).
+    // - The data requests are always remote.
+    // In case of local config, this FSM put a VCI response in CONFIG_RSP fifo.
+    // In case of remote transaction, it put the VCI command in CONFIG_CMD fifo.
+    ///////////////////////////////////////////////////////////////////////////////
 
     switch( r_config_cmd_fsm.read() ) 
     {
-    //////////////
-    case CONFIG_CMD_IDLE:
-    {
-        if ( p_vci_tgt_config.cmdval.read() ) 
-        {
+    /////////////////////
+    case CONFIG_CMD_IDLE:   // waiting VCI command
+    {
+        if ( p_vci_tgt_int.cmdval.read() ) 
+        {
+
 #if DEBUG_CONFIG_CMD
-if( m_debug_config_cmd_fsm )
-{
-    std::cout << "  <IOB.CONFIG_CMD_IDLE> Configuration command received!" <<std::endl;
-    std::cout << " address = " << std::hex << p_vci_tgt_config.address.read()
-              << " srcid = " << std::dec << p_vci_tgt_config.srcid.read()
-              << " trdid = " << p_vci_tgt_config.trdid.read()
-              << " wdata = " << std::hex << p_vci_tgt_config.wdata.read()
-              << " be = " << p_vci_tgt_config.be.read()
-              << " plen = " << std::dec << p_vci_tgt_config.plen.read() << std::endl;
-}
-#endif
-            paddr_t config_paddr = p_vci_tgt_config.address.read();
-   
-//           // Just to verify 
-//           if(! m_locality_table_config[config_paddr] ) //cannot receive remote packets
-//           {
-//           std::cout << "IOB ERROR " << name() << " CONFIG_CMD_IDLE state" << std::endl
-//                         << "Received a remote packet" << std::endl;
-//               exit(0);
-//           }
-
-            bool read = (p_vci_tgt_config.cmd.read() == vci_param_d::CMD_READ);
-            
-            uint32_t              cell    = (uint32_t)((config_paddr & 0x1FF)>>2); 
-            
-            // Treatement of received command
-            // Verifies error, tests if the the command is for IOB itself 
+if( m_debug_activated )
+std::cout << "  <IOB CONFIG_CMD_IDLE> Command received" 
+          << " / address = " << std::hex << p_vci_tgt_int.address.read()
+          << " / srcid = " << std::dec << p_vci_tgt_int.srcid.read()
+          << " / trdid = " << p_vci_tgt_int.trdid.read()
+          << " / wdata = " << std::hex << p_vci_tgt_int.wdata.read()
+          << " / be = " << p_vci_tgt_int.be.read()
+          << " / plen = " << std::dec << p_vci_tgt_int.plen.read()
+          << " / eop = " << p_vci_tgt_int.eop.read() << std::endl;
+#endif
+            vci_addr_t paddr = p_vci_tgt_int.address.read();
+            bool       read  = (p_vci_tgt_int.cmd.read() == vci_param_int::CMD_READ);
+            uint32_t   cell  = (uint32_t)((paddr & 0x1FF)>>2); 
  
-            // To IOB itself
-            if(m_segment_config.contains(config_paddr))
+            // The "local" segment must be the first in the seglist
+            soclib::common::Segment seg = m_int_seglist.front(); 
+           
+            if ( seg.contains(paddr) )  // IO_BRIDGE itself
             {
-                if(!read && (cell == IOB_IOMMU_PTPR)) 
-                    r_config_cmd_fsm = CONFIG_CMD_PTPR_WRITE;
-                else if(read && (cell == IOB_IOMMU_PTPR)) 
-                    r_config_cmd_fsm = CONFIG_CMD_PTPR_READ;
-                else if(!read && (cell == IOB_IOMMU_ACTIVE)) 
-                    r_config_cmd_fsm = CONFIG_CMD_ACTIVE_WRITE;
-                else if(read && (cell == IOB_IOMMU_ACTIVE)) 
-                    r_config_cmd_fsm = CONFIG_CMD_ACTIVE_READ;
-                else if(read && (cell == IOB_IOMMU_BVAR)) 
-                    r_config_cmd_fsm = CONFIG_CMD_BVAR_READ;
-                else if(read && (cell == IOB_IOMMU_ETR)) 
-                    r_config_cmd_fsm = CONFIG_CMD_ETR_READ;
-                else if(read && (cell == IOB_IOMMU_BAD_ID)) 
-                    r_config_cmd_fsm = CONFIG_CMD_BAD_ID_READ;
-                // PTE invalidation signaled by the OS
-                else if(!read && (cell == IOB_INVAL_PTE))
-                    r_config_cmd_fsm = CONFIG_CMD_INVAL_REQ;
-                else if(!read && (cell == IOB_IT_ADDR_IOMMU_LO)) 
-                    r_config_cmd_fsm = CONFIG_CMD_IT_ADDR_IOMMU_WRITE_1;
-                else if(read && (cell == IOB_IT_ADDR_IOMMU_LO)) 
-                    r_config_cmd_fsm = CONFIG_CMD_IT_ADDR_IOMMU_READ_1;
-                else if( !read && ((cell >= IOB_IT_ADDR_BEGIN)&&
-                        ( cell< (IOB_IT_ADDR_BEGIN +2*m_nb_periph-1) ) ) )
-                {
-                    // a factor two shows up because the registres come in couples
-                    r_it_index = (cell - IOB_IT_ADDR_BEGIN)/2;
-                    r_config_cmd_fsm = CONFIG_CMD_IT_ADDR_WRITE_1;
+                uint32_t      rdata  = 0;
+                bool          rerror = false;
+
+                if ( not read && (cell == IOB_IOMMU_PTPR) )       // WRITE PTPR
+                {
+                    r_iommu_ptpr = (uint32_t)p_vci_tgt_int.wdata.read();
+                }
+                else if ( read && (cell == IOB_IOMMU_PTPR) )      // READ PTPR 
+                {
+                    rdata = r_iommu_ptpr.read();
+                }
+                else if( not read && (cell == IOB_WTI_ENABLE))  // WRITE WTI_ENABLE
+                {
+                    r_iommu_wti_enable = p_vci_tgt_int.wdata.read();
+                }
+                else if( read && (cell == IOB_WTI_ENABLE))       // READ WTI ENABLE
+                {
+                    rdata = r_iommu_wti_enable.read();
+                }
+                else if( read && (cell == IOB_IOMMU_BVAR))        // READ BVAR
+                {
+                    rdata = r_iommu_bvar.read();
+                }
+                else if( read && (cell == IOB_IOMMU_ETR))          // READ ETR
+                {
+                    rdata = r_iommu_etr.read();
+                }
+                else if( read && (cell == IOB_IOMMU_BAD_ID))      // READ BAD_ID
+                {
+                    rdata = r_iommu_bad_id.read();
+                }
+                else if( not read && (cell == IOB_INVAL_PTE))     // WRITE INVAL_PTE
+                {
+                    r_config_tlb_req         = true;
+                    r_config_cmd_inval_vaddr = (uint32_t)p_vci_tgt_int.wdata.read();
+                }
+                else if( not read && (cell == IOB_WTI_ADDR_LO)) // WRITE WTI_PADDR_LO
+                {
+                    r_iommu_wti_paddr = (vci_addr_t)p_vci_tgt_int.wdata.read();
+                }
+                else if( read && (cell == IOB_WTI_ADDR_LO))    // READ WTI_PADDR_LO
+                {
+                    rdata = (uint32_t)r_iommu_wti_paddr.read();
+                }
+                else if( not read && (cell == IOB_WTI_ADDR_HI)) // WRITE WTI_PADDR_HI
+                {
+                    r_iommu_wti_paddr = (r_iommu_wti_paddr.read() & 0x00000000FFFFFFFFLL) |
+                                        ((vci_addr_t)p_vci_tgt_int.wdata.read())<<32;
+                }
+                else if( read && (cell == IOB_WTI_ADDR_HI))    // READ WTI_PADDR_HI
+                {
+                    rdata = (uint32_t)(r_iommu_wti_paddr.read()>>32);
+                }
+                else if( not read && ((cell >= IOB_PERI_WTI_BEGIN)  // WRITE PERI WTI
+                          && (cell< (IOB_PERI_WTI_BEGIN + 64))) )
+                {
+                    size_t  index = (cell - IOB_PERI_WTI_BEGIN)/2;
+                    bool    high  = (cell - IOB_PERI_WTI_BEGIN)%2;
+                    if ( high ) r_iommu_peri_wti[index] =          // set 32 MSB bits
+                        (r_iommu_peri_wti[index].read() & 0x00000000FFFFFFFFLL) |
+                        ((vci_addr_t)p_vci_tgt_int.wdata.read())<<32;
+                    else        r_iommu_peri_wti[index] =          // set 32 LSB bits
+                         (vci_addr_t)p_vci_tgt_int.wdata.read();
                 } 
-                else if( read && ((cell >= IOB_IT_ADDR_BEGIN)&&
-                        (cell< (IOB_IT_ADDR_BEGIN +2*m_nb_periph-1))) ) 
-                {
-                    r_it_index = (cell - IOB_IT_ADDR_BEGIN)/2;
-                    r_config_cmd_fsm = CONFIG_CMD_IT_ADDR_READ_1;
-                }
-                else
-                //Error. Wrong address, or invalid operation.
-                {
-                    if(read)    r_config_error_type = READ_ERROR;
-                    else        r_config_error_type = WRITE_ERROR;
-                    r_config_cmd_fsm = CONFIG_CMD_ERROR_WAIT; 
-                }
+                else if( read && ((cell >= IOB_PERI_WTI_BEGIN)      // READ PERI WTI    
+                         && (cell< (IOB_PERI_WTI_BEGIN + 64))) ) 
+                {
+                    size_t  index = (cell - IOB_PERI_WTI_BEGIN)/2;
+                    bool    high  = (cell - IOB_PERI_WTI_BEGIN)%2;
+                    if ( high ) rdata = (uint32_t)(r_iommu_peri_wti[index].read()>>32);
+                    else        rdata = (uint32_t)(r_iommu_peri_wti[index].read());
+                }
+                else   // Error: Wrong address, or invalid operation.
+                {
+                    rerror = true;
+                }
+                r_config_cmd_rdata  = rdata;
+                r_config_cmd_error = rerror;
+                r_config_cmd_fsm    = CONFIG_CMD_FIFO_PUT_RSP;
             }
-            // Must route the command to the correct IO
-            else
+            else                                        // remote peripheral
             {
-                if(!p_vci_tgt_config.eop.read())
-                {
-                    //Error
-                    if(read)    r_config_error_type = READ_ERROR;
-                    else        r_config_error_type = WRITE_ERROR;
-                    r_config_cmd_fsm = CONFIG_CMD_ERROR_WAIT; 
-                }
-                
-                // Find the corresponding address on IO Space
-//                int tgt_index = m_routing_table_config[config_paddr];
-//#if DEBUG_CONFIG_CMD
-//if( m_debug_config_cmd_fsm )
-//{
-//    std::cout << "  <IOB.CONFIG_CMD_IDLE> Routing a configuration packet" <<std::endl
-//            << "Target Index on Direct NoC: " << tgt_index << std::endl;
-//}
-//#endif
-//                soclib::common::Segment io_segment = m_mtio.getSegment(IntTab(tgt_index));
-//               #define L2 soclib::common::uint32_log2 
-//               paddr_t offset_mask = ( (1 << L2(io_segment.size())) - 1);
-//               #undef L2
-//               r_config_vaddr = (vaddr_t)( io_segment.baseAddress() | 
-//                               (vaddr_t)(config_paddr & offset_mask) ); 
-                
-                // TODO So far, it is in identity mapping
-                r_config_vaddr = (vaddr_t) config_paddr ; 
-                r_config_cmd_fsm	= CONFIG_CMD_TRT_LOCK;
-
+                r_config_cmd_fsm  = CONFIG_CMD_FIFO_PUT_CMD;
             }
-
-
         } // end if cmdval
         break;
     }
-    /////////////////////////
-    case CONFIG_CMD_TRT_LOCK: // Waiting for the lock to modify Transaction Table
-    {
-        if ( r_alloc_trt_config_fsm.read() == ALLOC_TRT_CONFIG_CMD ) 
+    /////////////////////////////
+    case CONFIG_CMD_FIFO_PUT_CMD:	// transmit VCI command from the INT network
+                                    // to the CONFIG_CMD fifo to IOX network 
+    {
+        config_cmd_fifo_put = true;
+
+        if ( p_vci_tgt_int.cmdval.read()  and m_config_cmd_addr_fifo.wok() )
         {
 
 #if DEBUG_CONFIG_CMD
-if( m_debug_config_cmd_fsm )
-{
-    std::cout << "  <IOB.CONFIG_CMD_TRT_LOCK> Check the TRT" << std::endl;
-}
-#endif
-            size_t 		wok_index = 0;
-            bool 		wok       = !m_transaction_tab_config.full(wok_index);
-
-            if ( wok ) 	// TRT isn't full. Write the new transaction. 
+if( m_debug_activated ) 
+std::cout << "  <IOB CONFIG_CMD_FIFO_PUT_CMD> Transmit VCI command to IOX network"
+          << " : address = " << std::hex << p_vci_tgt_int.address.read()
+          << " / srcid = " << p_vci_tgt_int.srcid.read()
+          << std::endl;
+#endif
+            if(  p_vci_tgt_int.eop.read() ) r_config_cmd_fsm = CONFIG_CMD_IDLE;
+        }
+        break;
+    }
+    /////////////////////////////
+    case CONFIG_CMD_FIFO_PUT_RSP:   // Try to put a response in CONFIG_RSP fifo,
+                                    // for a local configuration transaction.
+                                    // The FIFO is shared with CONFIG_RSP FSM 
+                                    // and must we wait for allocation...
+    {
+        if ( p_vci_tgt_int.cmdval.read() and r_alloc_fifo_config_rsp_local.read() )
+        {
+            config_rsp_fifo_put = true;
+
+            if ( m_config_rsp_data_fifo.wok() )  
             {
-                r_config_cmd_trt_index = (vci_trdid_t)wok_index;
-                r_config_cmd_fsm       = CONFIG_CMD_TRT_SET;
-            } 
-            else 		// wait an empty entry in TRT
-            {
-                r_config_cmd_fsm       = CONFIG_CMD_TRT_WAIT;
-                r_config_cmd_rsp_erase_req = true;
+
 #if DEBUG_CONFIG_CMD
-if( m_debug_config_cmd_fsm )
-{
-    std::cout << "  <IOB.CONFIG_CMD_TRT_LOCK> TRT is full. Going to TRT_WAIT state" << std::endl;
-}
-#endif
-            
-#ifdef INSTRUMENTATION        
-m_cpt_trt_config_full++;
-#endif
+if( m_debug_activated ) 
+std::cout << "  <IOB CONFIG_CMD_FIFO_PUT_RSP> Response to a local configuration request" 
+          << std::endl;
+#endif
+                if(  p_vci_tgt_int.eop.read() ) r_config_cmd_fsm = CONFIG_CMD_IDLE;
             }
         }
         break;
     }
-    ////////////////
-    case CONFIG_CMD_TRT_WAIT:	// release the lock protecting the transaction tab
-                                // waits that RSP erases an entry 
-    { 
-#ifdef INSTRUMENTATION        
-m_cpt_trt_config_full_cost++;
-#endif
-        // CONFIG_RSP will notify an erase action by reseting this register
-        if(!r_config_cmd_rsp_erase_req.read())
-        {
-            r_config_cmd_fsm = CONFIG_CMD_TRT_LOCK; // take the lock again
-        }
-        break;
-    }
-    ////////////////////////
-    case CONFIG_CMD_TRT_SET:	// register a new transaction in TRT
-    {  
-        if ( r_alloc_trt_config_fsm.read() == ALLOC_TRT_CONFIG_CMD ) 
-        {
-            m_transaction_tab_config.set(   r_config_cmd_trt_index.read(),
-                                            p_vci_tgt_config.srcid.read(), 
-                                            p_vci_tgt_config.trdid.read() );
-            
-            r_config_cmd_fsm = CONFIG_CMD_FIFO_PUT;
-#if DEBUG_CONFIG_CMD
-if( m_debug_config_cmd_fsm )
-{
-    std::cout << "  <IOB.CONFIG_CMD_TRT_SET> Set a new entry in TRT" << std::endl;
-}
-#endif
-        }
-        break;
-    }  
-    ///////////////////////
-    case CONFIG_CMD_FIFO_PUT:	 
-    {
-        if ( p_vci_tgt_config.cmdval && m_config_cmd_addr_fifo.wok() ) 
-        {
-            config_cmd_fifo_put = true;
-            if(  p_vci_tgt_config.eop )    r_config_cmd_fsm = CONFIG_CMD_IDLE;
-           
-#if DEBUG_CONFIG_CMD
-if( m_debug_config_cmd_fsm ) 
-{
-    std::cout << "  <IOB.CONFIG_CMD_FIFO_PUT> Push into config_cmd_fifo:" 
-              << " address = " << std::hex << r_config_vaddr.read()
-              << " srcid = " << std::dec << m_srcid_config
-              << " trdid = " << r_config_cmd_trt_index.read()
-              << " wdata = " << std::hex << p_vci_tgt_config.wdata.read()
-              << " be = " << p_vci_tgt_config.be.read()
-              << " plen = " << std::dec << p_vci_tgt_config.plen.read() << std::endl;
-}
-#endif
-        }
-        break;
-    }
-    
-    ///////////////////////////////
-    // Private Configuration States
-    ///////////////////////////////
-
-    //////////////////
-    case CONFIG_CMD_PTPR_WRITE: // Convention- The word received is in the format:
-                                // 00000 BASE_ADDRESS[39:13]
-                                // Same pattern as in iommu_ptpr register
-    {
-        if ( p_vci_tgt_config.cmdval.read() && m_config_local_data_fifo.wok()
-            && r_dma_tlb_fsm == DMA_TLB_IDLE )
-        {
-            // This verification could have been done on IDLE state
-            // It would save us one cycle 
-            if ( !p_vci_tgt_config.eop.read() )
-            {
-                std::cout << "CONFIG_CMD ERROR " << name() << " CONFIG_CMD_PTPR_WRITE state" << std::endl;
-                std::cout << " PTPR write command must contain one single flit" << std::endl;
-                r_config_error_type = WRITE_ERROR;
-                r_config_cmd_fsm = CONFIG_CMD_ERROR_WAIT; 
-                break;
-            }
-            
-            // Depends on the convention
-            r_iommu_ptpr = (uint32_t)(p_vci_tgt_config.wdata.read()); 
-            
-            config_local_fifo_put = true;
-            r_config_cmd_fsm = CONFIG_CMD_IDLE;
-
-#if DEBUG_CONFIG_CMD
-if( m_debug_config_cmd_fsm ) 
-{
-    std::cout << "  <IOB.CONFIG_CMD_PTPR_WRITE> PTPR received:" 
-              << "r_iommu_ptpr = " << std::hex << (p_vci_tgt_config.wdata.read())
-              <<std::endl;
-}
-#endif
-        } 
-        break;
-    }
+    } // end switch CONFIG_CMD FSM
+
+    //////////////////////////////////////////////////////////////////////////////
+    // The CONFIG_RSP_FSM handles the VCI responses from the periherals 
+    // on the IOX network and  writes the responses in the CONFIG_RSP fifo.
+    // The VCI response flit is only consumed in the FIFO_PUT state.
+    // This FSM is mainly intended to handle single flit config transactions, 
+    // but it can also handle software driven, multi-flits data transactions.
+    //////////////////////////////////////////////////////////////////////////////
+
+    switch( r_config_rsp_fsm.read() ) 
+    {
     /////////////////////
-    case CONFIG_CMD_ACTIVE_WRITE: 
-    {
-        if ( p_vci_tgt_config.cmdval.read() && m_config_local_data_fifo.wok() 
-            && r_dma_tlb_fsm == DMA_TLB_IDLE )
-        {
-            // This verification could have been done on IDLE state
-            // It would save us one cycle 
-            if ( !p_vci_tgt_config.eop.read() )
-            {
-                std::cout << "CONFIG_CMD ERROR " << name() << " CONFIG_CMD_ACTIVE_WRITE state" << std::endl;
-                std::cout << " ACTIVE write command must contain one single flit" << std::endl;
-                r_config_error_type = WRITE_ERROR;
-                r_config_cmd_fsm = CONFIG_CMD_ERROR_WAIT; 
-                break;
-            }
-            
-            r_iommu_active = (p_vci_tgt_config.wdata.read() != 0);
-            
-            config_local_fifo_put = true;
-            r_config_cmd_fsm = CONFIG_CMD_IDLE;
-        } 
-        break;
-    }
-    ///////////////////
-    case CONFIG_CMD_INVAL_REQ: // Blocks in case of untreated request
-    {   
-        if ( !r_config_tlb_req.read() )
-        {
-            r_config_tlb_req = true;     
-            r_config_cmd_fsm = CONFIG_CMD_INVAL;
-        } 
-        break;
-    }
-    ///////////////////
-    case CONFIG_CMD_INVAL: // Consuming the 32bit Virtual Address of the invalidated page
-    {
-        if ( p_vci_tgt_config.cmdval.read() && 
-                m_config_local_data_fifo.wok() ) 
-        {
-            
-            if ( !p_vci_tgt_config.eop.read() )
-            {
-                std::cout << "CONFIG_CMD ERROR " << name() << " CONFIG_CMD_INVAL state" << std::endl;
-                std::cout << " PTE invalidation commands must contain one single flit" << std::endl;
-                r_config_error_type = WRITE_ERROR;
-                r_config_cmd_fsm = CONFIG_CMD_ERROR_WAIT; 
-                break;
-            }
-            
-            assert( (p_vci_tgt_config.wdata.read()& K_PAGE_OFFSET_MASK) == 0 
-                    and " Error : Invalid format for Page Virtual Address. At least the 12 LSB bits must be zero");
-
-            r_config_tlb_inval_vaddr = (vaddr_t)(p_vci_tgt_config.wdata.read());
-             
-            config_local_fifo_put = true;
-            r_config_cmd_fsm = CONFIG_CMD_IDLE;
-        } 
-        break;
-    }
-    //////////////////
-    case CONFIG_CMD_IT_ADDR_IOMMU_WRITE_1: 
-    {
-        if ( p_vci_tgt_config.cmdval.read() && m_config_local_data_fifo.wok())
-        {
-            if(vci_param_d::N <= 32)
-            {
-            // address holds in one single flit
-                if (!p_vci_tgt_config.eop.read() )
-                {
-                    
-                    std::cout << "CONFIG_CMD ERROR " << name() << " CONFIG_CMD_IT_ADDR_IOMMU_WRITE_1 state" << std::endl;
-                    std::cout << " PTE invalidation command should contain just one flit" << std::endl;
-                    r_config_error_type = WRITE_ERROR;
-                    r_config_cmd_fsm = CONFIG_CMD_ERROR_WAIT;
-                }
-                else
-                {
-                    // If physical address holds on a single word
-                    r_it_addr[r_it_index.read()] = (paddr_t)(p_vci_tgt_config.wdata.read()); 
-                 
-                    config_local_fifo_put = true; 
-                    r_config_cmd_fsm = CONFIG_CMD_IDLE;
-                }
-        
-            }
-            else
-            {
-            // two flits are required to send address
-                if ( p_vci_tgt_config.eop.read() )
-                {
-                    
-                    std::cout << "CONFIG_CMD ERROR " << name() << " CONFIG_CMD_IT_ADDR_IOMMU_WRITE_1 state" << std::endl;
-                    std::cout << " PTE invalidation commands should contain two flits" << std::endl;
-                    r_config_error_type = WRITE_ERROR;
-                    r_config_cmd_fsm = CONFIG_CMD_ERROR_RSP;
-                }
-                else
-                {
-                    r_config_first_word = p_vci_tgt_config.wdata.read(); 
-                    r_config_cmd_fsm = CONFIG_CMD_IT_ADDR_IOMMU_WRITE_2;
-                }
-            }
-        } 
-        break;
-    }
-    /////////////////
-    case CONFIG_CMD_IT_ADDR_IOMMU_WRITE_2: 
-    {
-        if ( p_vci_tgt_config.cmdval.read() && m_config_local_data_fifo.wok() )
-        {
-            if ( !p_vci_tgt_config.eop.read() )
-            {
-                std::cout << "CONFIG_CMD ERROR " << name() << " CONFIG_CMD_IT_IOMMU_WRITE_2 state" << std::endl;
-                std::cout << " PTE invalidation commands must contain two flits" << std::endl;
-                r_config_error_type = WRITE_ERROR;
-                r_config_cmd_fsm = CONFIG_CMD_ERROR_WAIT; 
-                break;
-            }
-            
-            // Depends on the convention
-            size_t mask_msb = (1 << (vci_param_d::N - 32)) - 1 ;
-            r_it_addr_iommu = (paddr_t)(r_config_first_word.read() |
-                                   ((p_vci_tgt_config.wdata.read()& mask_msb)<<32)); 
-             
-            config_local_fifo_put = true;
-            r_config_cmd_fsm = CONFIG_CMD_IDLE;
-        } 
-    }
-    //////////////////
-    case CONFIG_CMD_IT_ADDR_WRITE_1: 
-    {
-        if ( p_vci_tgt_config.cmdval.read() && m_config_local_data_fifo.wok())
-        {
-            if(vci_param_d::N <= 32)
-            {
-            // address holds in one single flit
-                if (!p_vci_tgt_config.eop.read() )
-                {
-                    
-                    std::cout << "CONFIG_CMD ERROR " << name() << " CONFIG_CMD_IT_ADDR_WRITE_1 state" << std::endl;
-                    std::cout << " PTE invalidation command should contain just one flit" << std::endl;
-                    r_config_error_type = WRITE_ERROR;
-                    r_config_cmd_fsm = CONFIG_CMD_ERROR_WAIT;
-                    
-                   
-                }
-                else
-                {
-                    // If physical address holds on a single word
-                    r_it_addr[r_it_index.read()] = (paddr_t)(p_vci_tgt_config.wdata.read()); 
-                 
-                    config_local_fifo_put = true; 
-                    r_config_cmd_fsm = CONFIG_CMD_IDLE;
-                }
-        
-            }
-            else
-            {
-            // two flits are required to send address
-                if ( p_vci_tgt_config.eop.read() )
-                {
-                    
-                    std::cout << "CONFIG_CMD ERROR " << name() << " CONFIG_CMD_IT_ADDR_WRITE_1 state" << std::endl;
-                    std::cout << " PTE invalidation commands should contain two flits" << std::endl;
-                    r_config_error_type = WRITE_ERROR;
-                    r_config_cmd_fsm = CONFIG_CMD_ERROR_RSP;
-                }
-                else
-                {
-                    r_config_first_word = p_vci_tgt_config.wdata.read();
-                    r_config_cmd_fsm = CONFIG_CMD_IT_ADDR_WRITE_2;
-                }
-            } 
-        } 
-        break;
-    }
-    /////////////////
-    case CONFIG_CMD_IT_ADDR_WRITE_2: 
-    {
-        if ( p_vci_tgt_config.cmdval.read() && m_config_local_data_fifo.wok() )
-        {
-            if ( !p_vci_tgt_config.eop.read() )
-            {
-                std::cout << "CONFIG_CMD ERROR " << name() << " CONFIG_CMD_IT_ADDR_WRITE_2 state" << std::endl;
-                std::cout << " PTE invalidation commands must contain two flits" << std::endl;
-                r_config_error_type = WRITE_ERROR;
-                r_config_cmd_fsm = CONFIG_CMD_ERROR_WAIT; 
-                break;
-            }
-            
-            // Depends on the convention
-            size_t mask_msb = (1 << (vci_param_d::N - 32)) - 1 ;
-            r_it_addr[r_it_index.read()] = (paddr_t)(r_config_first_word.read() |
-                                ((p_vci_tgt_config.wdata.read()& mask_msb)<<32)); 
-             
-            config_local_fifo_put = true;
-            r_config_cmd_fsm = CONFIG_CMD_IDLE;
-        } 
-    }
-    //////////////////
-    case CONFIG_CMD_PTPR_READ: 
-    case CONFIG_CMD_ACTIVE_READ:
-    case CONFIG_CMD_BVAR_READ:
-    case CONFIG_CMD_ETR_READ:
-    case CONFIG_CMD_BAD_ID_READ:
-    case CONFIG_CMD_IT_ADDR_IOMMU_READ_1:
-    case CONFIG_CMD_IT_ADDR_READ_1:
-    {
-        if ( p_vci_tgt_config.cmdval.read() && m_config_local_data_fifo.wok() )
-        {
-            // This verification could have been done on IDLE state
-            // It would save us one cycle 
-            if ( !p_vci_tgt_config.eop.read() )
-            {
-                std::cout << "CONFIG_CMD ERROR " << name() << config_cmd_fsm_state_str[r_config_cmd_fsm.read()] << std::endl;
-                std::cout << " Read commands must contain one single flit" << std::endl;
-                r_config_error_type = READ_ERROR;
-                r_config_cmd_fsm = CONFIG_CMD_ERROR_WAIT; 
-                break;
-            }
-            
-            // fifo data receives the content of the corresponding register 
-            // (depending on the current state) 
-            config_local_fifo_put = true;
-            if(r_config_cmd_fsm.read()== CONFIG_CMD_IT_ADDR_READ_1)
-            r_config_cmd_fsm = CONFIG_CMD_IT_ADDR_READ_2;
-            else if(r_config_cmd_fsm.read()== CONFIG_CMD_IT_ADDR_IOMMU_READ_1)
-            r_config_cmd_fsm = CONFIG_CMD_IT_ADDR_IOMMU_READ_2;
-            else
-            r_config_cmd_fsm = CONFIG_CMD_IDLE;
-        } 
-        break;
-    }
-    //////////////////
-    case CONFIG_CMD_IT_ADDR_READ_2:
-    case CONFIG_CMD_IT_ADDR_IOMMU_READ_2:
-    {
-        if ( p_vci_tgt_config.cmdval.read() && m_config_local_data_fifo.wok() )
-        {
-            config_local_fifo_put = true;
-            r_config_cmd_fsm = CONFIG_CMD_IDLE;
-        } 
-    }
-    //////////////////
-    case CONFIG_CMD_ERROR_WAIT: //receives the other flits of the same transaction
-    {
-        if ( p_vci_tgt_config.cmdval.read() && p_vci_tgt_config.eop.read() ) 
-        r_config_cmd_fsm = CONFIG_CMD_ERROR_RSP; 
-    }
-    ///////////////////
-    case CONFIG_CMD_ERROR_RSP:
-    {
-        if ( m_config_local_data_fifo.wok() )
-        {
-            config_local_fifo_put = true;
-            r_config_cmd_fsm = CONFIG_CMD_IDLE;
-        }
-        break;
-    }
-
-    } // end switch CONFIG_CMD FSM
-
-    /////////////////////////////////////////////////////////////////////
-    // The CONFIG_RSP_FSM controls the following ressources:
-    // - r_config_rsp_fsm
-    // - r_config_cmd_rsp_erase_req (reset) 
-    // - 
-    // - 
-    //////////////////////////////////////////////////////////////////////////////
-    switch( r_config_rsp_fsm.read() ) 
-    {
-    /////////////////////
-    case CONFIG_RSP_IDLE:
+    case CONFIG_RSP_IDLE:  // waiting a VCI response from IOX network
     {    	
-        if(p_vci_ini_config.rspval.read()) 
+        if ( p_vci_ini_iox.rspval.read() ) 
 		{
-            r_config_rsp_fsm = CONFIG_RSP_TRT_LOCK;
+            r_config_rsp_fsm = CONFIG_RSP_FIFO_PUT;
 		}
 		break;
     }
-    /////////////////////
-    case CONFIG_RSP_TRT_LOCK:
-    {    	
-        if ( r_alloc_trt_config_fsm.read() == ALLOC_TRT_CONFIG_RSP ) 
-        {
-            
-#if DEBUG_CONFIG_RSP
-if( m_debug_config_rsp_fsm )
-{
-    std::cout << "  <IOB.CONFIG_RSP_TRT_LOCK> Read and erase entry" << std::endl;
-}
-#endif
-            uint32_t trdid_iospace = p_vci_ini_config.rtrdid.read(); 
-            
-            r_config_rsrcid = (vci_srcid_t)m_transaction_tab_config.readSrcid(trdid_iospace);
-            r_config_rtrdid = (vci_trdid_t)m_transaction_tab_config.readTrdid(trdid_iospace);
-            m_transaction_tab_config.erase(trdid_iospace);
-            if (r_config_cmd_rsp_erase_req.read()) r_config_cmd_rsp_erase_req = false;
-            r_config_rsp_fsm       = CONFIG_RSP_FIFO_PUT;
-        }        
-		break;
-    }
-    //////////////////
-    case CONFIG_RSP_FIFO_PUT:
-    {
-        if(p_vci_ini_config.rspval.read() && m_config_rsp_data_fifo.wok())
+    /////////////////////////
+    case CONFIG_RSP_FIFO_PUT:  // try to write into CONFIG_RSP fifo
+                               // as soon as it is allocated
+    {
+        if ( p_vci_ini_iox.rspval.read() and not r_alloc_fifo_config_rsp_local.read() )
     	{
             config_rsp_fifo_put = true;
-            if(p_vci_ini_config.reop.read())   r_config_rsp_fsm = CONFIG_RSP_IDLE;	
+
+            if ( m_config_rsp_data_fifo.wok() )	
+            {
+                if ( p_vci_ini_iox.reop.read() ) r_config_rsp_fsm = CONFIG_RSP_IDLE;	
 
 #if DEBUG_CONFIG_RSP
-if( m_debug_config_rsp_fsm ) 
-{
-    std::cout << "  <IOB.CONFIG_RSP_FIFO_PUT> Push into rsp_fifo:" 
-              << " rsrcid = " << std::dec << r_config_rsrcid.read()
-              << " rtrdid = " << r_config_rtrdid.read()
-              << " rdata = " << std::hex << p_vci_ini_config.rdata.read()
-    << std::endl;
-}
-#endif
+if( m_debug_activated ) 
+std::cout << "  <IOB CONFIG_RSP_FIFO_PUT> Push response into CONFIG_RSP fifo:" 
+          << " / rsrcid = " << std::hex << p_vci_ini_iox.rsrcid.read()
+          << " / rtrdid = " << p_vci_ini_iox.rtrdid.read()
+          << " / rdata = " << p_vci_ini_iox.rdata.read()
+          << " / reop  = " << p_vci_ini_iox.reop.read()
+          << " / rerror = " << p_vci_ini_iox.rerror.read() << std::endl;
+#endif
+            }
     			
     	}
